//+------------------------------------------------------------------+
//|                                                          Ema.mq4 |
//|      (MQL4.ru)                             |
//+------------------------------------------------------------------+
extern double     Lots=0.1;
extern double      Pip=5;
extern double MoveBack=3;
extern int         chk=0;
extern int         MA1=10;
extern int         MA2=20;
extern int         MA3=50;
extern int         MA4=100;
extern int         Mode_MA=1;
extern int         Price_MA=1;
extern int         Shift_MA1=0;
extern int         Shift_MA2=0;
extern int         Shift_MA3=0;
extern int         Shift_MA4=0;
extern double       SL=150;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
//----
datetime Tm=GlobalVariableSet("Tm",0);
int WaitNapr=GlobalVariableSet("WaitNapr",0);
//----
   return(0);
  }

int start()
  {
   double hi=High[1];
   double lo=Low[1];
   double EMA1, EMA2, EMA3, EMA4, EMA1s, EMA2s, EMA3s, EMA4s;
   int WaitNapr=GlobalVariableGet("WaitNapr");
   int cnt=0, ticket, total;

  if (iTime(NULL,0,0)!=GlobalVariableGet("Tm"))
   { 
      GlobalVariableSet("Tm",iTime(NULL,0,0));
   EMA1=iMA(0,0,MA1,0,Mode_MA,Price_MA,Shift_MA1);
   EMA2=iMA(0,0,MA2,0,Mode_MA,Price_MA,Shift_MA2);
   EMA3=iMA(0,0,MA3,0,Mode_MA,Price_MA,Shift_MA3);
   EMA4=iMA(0,0,MA4,0,Mode_MA,Price_MA,Shift_MA4);
   EMA1s=iMA(0,0,MA1,0,Mode_MA,Price_MA,Shift_MA1+1);
   EMA2s=iMA(0,0,MA2,0,Mode_MA,Price_MA,Shift_MA2+1);
   EMA3s=iMA(0,0,MA3,0,Mode_MA,Price_MA,Shift_MA3+1);
   EMA4s=iMA(0,0,MA4,0,Mode_MA,Price_MA,Shift_MA4+1);
   
   if(((EMA3>EMA4) && (EMA3s<=EMA4s) && (EMA1>EMA2)) || ((EMA1>EMA2) && (EMA1s<=EMA2s) && (EMA3>EMA4))) WaitNapr=1;
   if(((EMA3<EMA4) && (EMA3s>=EMA4s) && (EMA1<EMA2)) || ((EMA1<EMA2) && (EMA1s>=EMA2s) && (EMA3<EMA4))) WaitNapr=-1;
   
   total=OrdersTotal();
   if(total<1)
     {
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("   .   = ", AccountFreeMargin());
         return(0);
        }
      if((WaitNapr!=0) && (GlobalVariableGet("WaitNapr")!=WaitNapr))
        {
         if(WaitNapr<0)
           {
            ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,NormalizeDouble(Bid+SL*Point,4),0,
            "EMA position:",16385,0,Red);
            if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
                  Print("  SELL : ",OrderOpenPrice());
               chk=0;
              }
            else
              {
               Print("  SELL  : ",GetLastError());
               return(0);
              }
           }
         if(WaitNapr>0)
           {
            ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,NormalizeDouble(Ask-SL*Point,4),0,
            "EMA position:",16385,0,Green);
            if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
                  Print("  BUY : ",OrderOpenPrice());
               chk=0;
              }
            else
              {
               Print("  BUY  : ",GetLastError());
               return(0);
              }
           }
        }
      return(0);
     }
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   //   ? OP_BUY  OP_SELL 
         OrderSymbol()==Symbol())  //  ?
        {
         if(OrderType()==OP_BUY)   //   
           {
            // ,    ?
            if (EMA1<EMA2)
              {
               chk=0;
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); //  
               return(0); // 
              }
           }
         else //    
           {
            // ,    ?
            if(EMA1>EMA2)
              {
               chk=0;
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); //  
               return(0); // 
              }
           }
        }
     }
   }
   if (GlobalVariableGet("WaitNapr")!=WaitNapr) GlobalVariableSet("WaitNapr",WaitNapr);
   return(0);
  }
//+------------------------------------------------------------------+